<template>
  <div style="height: 100%">
    <div class="ag-btn-group">
      <v-speed-dial
        v-model="fab"
        direction="top"
        bottom
        right
        open-on-hover
        transition="slide-y-reverse-transition"
      >
        <template v-slot:activator>
          <v-btn v-model="fab" dark color="blue darken-2" fab small>
            <v-icon v-if="fab">mdi-close</v-icon>
            <v-icon v-else>mdi-account-cog-outline</v-icon>
          </v-btn>
        </template>

        <v-btn
          fab
          dark
          small
          color="green"
          class="ag-btn exitBtn"
          :class="{ disabled: !readyState }"
          title="Exit"
          @click="handleExit"
        >
          <v-icon class="ag-icon ag-icon-leave">mdi-location-exit</v-icon>
        </v-btn>
        <v-btn
          v-if="attendeeMode === 'video'"
          fab
          dark
          small
          color="indigo"
          class="ag-btn videoControlBtn"
          title="Enable/Disable Video"
          @click="handleCamera"
        >
          <v-icon class="ag-icon ag-icon-camera">mdi-camera-off</v-icon>
          <v-icon class="ag-icon ag-icon-camera-off">mdi-camera</v-icon>
        </v-btn>

        <v-btn
          fab
          dark
          small
          color="red"
          class="ag-btn audioControlBtn"
          title="Enable/Disable Audio"
          @click="handleMic"
        >
          <v-icon class="ag-icon ag-icon-mic">mdi-microphone-outline</v-icon>
          <v-icon class="ag-icon ag-icon-mic-off">mdi-microphone-off</v-icon>
        </v-btn>

        <v-btn
          fab
          dark
          small
          color="yellow"
          class="ag-btn displayModeBtn"
          :class="{ disabled: streamList.length > 4 }"
          title="Switch Display Mode"
          @click="switchDisplay"
        >
          <v-icon class="ag-icon ag-icon-switch-display">mdi-eye</v-icon>
        </v-btn>

        <v-btn
          fab
          dark
          small
          class="ag-btn disableRemoteBtn"
          :class="{ disabled: streamList.length > 4 || displayMode !== 'pip' }"
          title="Hide Remote Stream"
          @click="hideRemote"
        >
          <v-icon class="ag-icon ag-icon-remove-pip"
            >mdi-minus-circle-outline</v-icon
          >
        </v-btn>
      </v-speed-dial>
    </div>
    <div id="ag-canvas">
      <div class="effect">
        <fire-effect />
      </div>
    </div>
  </div>
</template>

<script>
import { merge } from 'lodash'
import AgoraRTC from 'agora-rtc-sdk'
import FireEffect from '../Effects/Fire'

const tileCanvas = {
  '1': ['span 12/span 24'],
  '2': ['span 12/span 12/19/14', 'span 12/span 12/20/14'],
  '3': ['span 12/span 2/23/3', 'span 12/span 3/25/24', 'span 12/span 6/12/18'],
  '4': [
    'span 12/span 6/16/12',
    'span 1/span 7/11/24',
    'span 1/span 5/14/17',
    'span 12/span 5/4/16'
  ],
  '5': [
    'span 3/span 1/15/9',
    'span 12/span 4/21/11',
    'span 1/span 7/6/24',
    'span 12/span 1/5/14',
    'span 12/span 5/4/16'
  ],
  '6': [
    'span 3/span 4/13/7',
    'span 3/span 4/13/11',
    'span 3/span 4/13/15',
    'span 3/span 4/13/19',
    'span 3/span 4/13/23',
    'span 9/span 16/10/21'
  ],
  '7': [
    'span 3/span 4/13/5',
    'span 3/span 4/13/9',
    'span 3/span 4/13/13',
    'span 3/span 4/13/17',
    'span 3/span 4/13/21',
    'span 3/span 4/13/25',
    'span 9/span 16/10/21'
  ]
}
export default {
  components: {
    FireEffect
  },
  props: [
    'transcode',
    'attendeeMode',
    'videoProfile',
    'channel',
    'baseMode',
    'appId',
    'uid'
  ],
  data() {
    return {
      client: {},
      localStream: {},
      shareClient: {},
      shareStream: {},
      displayMode: 'pip',
      streamList: [],
      readyState: false,
      fab: false
    }
  },
  created() {
    const $ = this
    // init AgoraRTC local client
    $.client = AgoraRTC.createClient({ mode: $.transcode })
    $.client.init($.appId, () => {
      console.log('AgoraRTC client initialized')
      $.subscribeStreamEvents()
      $.client.join($.appId, $.channel, $.uid, uid => {
        console.log(`User ${uid} join channel successfully`)
        console.log(`At ${new Date().toLocaleTimeString()}`)
        // create local stream
        // It is not recommended to setState in function addStream
        $.localStream = this.streamInit(uid, $.attendeeMode, $.videoProfile)
        $.localStream.init(
          () => {
            if ($.attendeeMode !== 'audience') {
              $.addStream($.localStream, true)
              $.client.publish($.localStream, err => {
                console.log(`Publish local stream error: ${err}`)
              })
            }
            $.readyState = true
          },
          err => {
            console.log(`getUserMedia failed ${err}`)
            $.readyState = true
          }
        )
      })
    })
  },
  mounted() {},
  beforeUpdate() {
    const $ = this
    // rerendering
    const canvas = document.querySelector('#ag-canvas')
    // pip mode (can only use when less than 4 people in channel)
    if ($.displayMode === 'pip') {
      const no = $.streamList.length
      if (no > 4) {
        $.displayMode = 'tile'
        return
      }
      $.streamList.forEach((item, index) => {
        const id = item.getId()
        let dom = document.querySelector(`#ag-item-${id}`)
        if (!dom) {
          dom = document.createElement('section')
          dom.setAttribute('id', `ag-item-${id}`)
          dom.setAttribute('class', 'ag-item')
          canvas.appendChild(dom)
          item.play(`ag-item-${id}`)
        }
        console.log(no)
        if (index === no - 1) {
          dom.setAttribute('style', `grid-area: span 12/span 5/6/17`)
        } else {
          // dom.setAttribute('style', `grid-area: span 12/span 5/${4 + 3 * index}/11; z-index:1; width:calc(100% - 20px); height:calc(100% - 20px);`)
          dom.setAttribute('style', `grid-area: ${tileCanvas[no][index]}`)
        }
        if (item.player.resize) item.player.resize()
      })
    } else if ($.displayMode === 'tile') {
      // tile mode
      const no = $.streamList.length
      $.streamList.forEach((item, index) => {
        const id = item.getId()
        let domSelector = document.querySelector(`#ag-item-${id}`)
        if (!domSelector) {
          domSelector = document.createElement('section')
          domSelector.setAttribute('id', `ag-item-${id}`)
          domSelector.setAttribute('class', 'ag-item')
          canvas.appendChild(domSelector)
          item.play(`ag-item-${id}`)
        }
        domSelector.setAttribute('style', `grid-area: ${tileCanvas[no][index]}`)
        item.player.setAttribute('style', 'background-color: red')
        if (item.player.resize) item.player.resize()
      })
    } else if ($.displayMode === 'share') {
      // screen share mode (tbd)
    }
  },
  beforeDestroy() {
    if (this.client) this.client.unpublish(this.localStream)
    if (this.localStream) this.localStream.close()
    if (this.client) {
      this.client.leave(
        () => {
          console.log('Client succeed to leave.')
        },
        () => {
          console.log('Client failed to leave.')
        }
      )
    }
  },

  methods: {
    streamInit(uid, attendeeMode, videoProfile, config) {
      const defaultConfig = {
        streamID: uid,
        audio: true,
        video: true,
        screen: false
      }
      switch (attendeeMode) {
        case 'audio-only':
          defaultConfig.video = false
          break
        case 'audience':
          defaultConfig.video = false
          defaultConfig.audio = false
          break
        default:
        case 'video':
          break
      }
      const stream = AgoraRTC.createStream(merge(defaultConfig, config))
      stream.setVideoProfile(videoProfile)
      return stream
    },
    subscribeStreamEvents() {
      const rt = this
      rt.client.on('stream-added', evt => {
        const { stream } = evt
        console.log(`New stream added: ${stream.getId()}`)
        console.log(`At ${new Date().toLocaleTimeString()}`)
        console.log(`Subscribe ${stream}`)
        rt.client.subscribe(stream, err => {
          console.log(`Subscribe stream failed ${err}`)
        })
      })
      rt.client.on('peer-leave', evt => {
        console.log(`Peer has left: ${evt.uid}`)
        console.log(new Date().toLocaleTimeString())
        console.log(evt)
        rt.removeStream(evt.uid)
      })
      rt.client.on('stream-subscribed', evt => {
        const { stream } = evt
        console.log('Got stream-subscribed event')
        console.log(new Date().toLocaleTimeString())
        console.log(`Subscribe remote stream successfully: ${stream.getId()}`)
        console.log(evt)
        rt.addStream(stream)
      })
      rt.client.on('stream-removed', evt => {
        const { stream } = evt
        console.log(`Stream removed: ${stream.getId()}`)
        console.log(new Date().toLocaleTimeString())
        console.log(evt)
        rt.removeStream(stream.getId())
      })
    },
    removeStream(uid) {
      this.streamList.forEach((item, index) => {
        if (item.getId() === uid) {
          item.close()
          const element = document.querySelector(`#ag-item-${uid}`)
          if (element) {
            element.parentNode.removeChild(element)
          }
          const tempList = [...this.streamList]
          tempList.splice(index, 1)
          this.streamList = tempList
        }
      })
    },
    addStream(stream, push = false) {
      const repeatition = this.streamList.some(item => {
        return item.getId() === stream.getId()
      })
      if (repeatition) {
        return
      }
      if (push) {
        this.streamList = this.streamList.concat([stream])
      } else {
        this.streamList = [stream].concat(this.streamList)
      }
    },
    handleCamera(e) {
      e.currentTarget.classList.toggle('off')
      console.log(e.currentTarget.classList)
      if (this.localStream.isVideoOn()) {
        this.localStream.disableVideo()
      } else {
        this.localStream.enableVideo()
      }
    },
    handleMic(e) {
      e.currentTarget.classList.toggle('off')
      if (this.localStream.isAudioOn()) {
        this.localStream.disableAudio()
      } else {
        this.localStream.enableAudio()
      }
    },
    switchDisplay(e) {
      if (
        e.currentTarget.classList.contains('disabled') ||
        this.streamList.length <= 1
      ) {
        return
      }
      if (this.displayMode === 'pip') {
        this.displayMode = 'tile'
      } else if (this.displayMode === 'tile') {
        this.displayMode = 'pip'
      } else if (this.displayMode === 'share') {
        // do nothing or alert, tbd
      } else {
        console.error('Display Mode can only be tile/pip/share')
      }
    },
    hideRemote(e) {
      if (
        e.currentTarget.classList.contains('disabled') ||
        this.streamList.length <= 1
      ) {
        return
      }
      const id = this.streamList[this.streamList.length - 1].getId()
      const list = Array.from(
        document.querySelectorAll(`.ag-item:not(#ag-item-${id})`)
      )
      list.forEach(item => {
        if (item.style.display !== 'none') {
          item.style.display = 'none'
        } else {
          item.style.display = 'block'
        }
      })
    },
    handleExit(e) {
      if (e.currentTarget.classList.contains('disabled')) {
        return
      }
      try {
        if (this.client) this.client.unpublish(this.localStream)
        if (this.localStream) this.localStream.close()
        if (this.client) {
          this.client.leave(
            () => {
              console.log('Client succeed to leave.')
            },
            () => {
              console.log('Client failed to leave.')
            }
          )
        }
      } finally {
        this.readyState = false
        this.client = null
        this.localStream = null
        // redirect to index
        this.$router.push('/')
      }
    }
  }
}
</script>

<style>
#ag-canvas {
  height: 100%;
  display: grid;
  grid-gap: 10px;
  grid-template-rows: repeat(12, auto);
  grid-template-columns: repeat(24, auto);
  background: #000;
}
.ag-item :first-child {
  background: transparent !important;
}
.ag-item {
  background: transparent !important;
  border-radius: 6px;
  height: 100%;
  width: 100%;
  width: 200px !important;
  height: 200px !important;
}
#ag-resize-container {
  background-image: none !important;
  /* background-color: black; */
  display: flex;
  justify-content: center;
  height: center;
}
#ag-resize-container .ag-item {
  border: none !important;
}
/* button group */
.ag-btn-group {
  background: transparent;
  z-index: 11;
  position: absolute;
  bottom: 0;
  right: 5px;
}

.ag-btn {
  z-index: 12;
  opacity: 0;
  color: white;
  /* width: 35px
    height: 35px */
  cursor: pointer;
  font-size: 60px;
  display: inline-flex;
  justify-content: center;
  align-items: center;
}
.ag-btn:hover {
  color: #00b6ed;
}
.ag-btn.disabled,
.ag-btn.disabled:hover {
  color: #637c8e;
  cursor: not-allowed;
}
.ag-btn-group:hover .ag-btn,
.ag-btn-group.active .ag-btn {
  opacity: 1;
}
.ag-btn.off.videoControlBtn .ag-icon-camera {
  display: none;
}
.ag-btn.videoControlBtn .ag-icon-camera-off {
  display: none;
}
.ag-btn.videoControlBtn .ag-icon-camera {
  display: inline-block;
}
.ag-btn.off.videoControlBtn .ag-icon-camera-off {
  display: inline-block;
}
.ag-btn.off.audioControlBtn .ag-icon-mic {
  display: none;
}
.ag-btn.audioControlBtn .ag-icon-mic-off {
  display: none;
}
.ag-btn.audioControlBtn .ag-icon-mic {
  display: inline-block;
}
.ag-btn.off.audioControlBtn .ag-icon-mic-off {
  display: inline-block;
}
video {
  max-width: unset !important;
  border-radius: 100%;
  background: transparent;
}
</style>
